import * as tapable from "tapable";
import { Callback } from "tapable";
import type { FSWatcher } from "chokidar";
import * as binding from "@rspack/binding";
import { Logger } from "./logging/Logger";
import type { Watch } from "./config/watch";
import { RspackOptionsNormalized } from "./config";
import { Stats } from "./stats";
import { Compilation } from "./compilation";
import ResolverFactory from "./ResolverFactory";
declare class Compiler {
    #private;
    webpack: any;
    compilation: Compilation;
    root: Compiler;
    resolverFactory: ResolverFactory;
    infrastructureLogger: any;
    watcher: FSWatcher;
    outputPath: string;
    name: string;
    inputFileSystem: any;
    outputFileSystem: any;
    context: string;
    hooks: {
        done: tapable.AsyncSeriesHook<Stats>;
        afterDone: tapable.SyncHook<Stats>;
        compilation: tapable.SyncHook<Compilation>;
        thisCompilation: tapable.SyncHook<[Compilation]>;
        invalid: tapable.SyncHook<[string | null, number]>;
        compile: tapable.SyncHook<[any]>;
        initialize: tapable.SyncHook<[]>;
        infrastructureLog: tapable.SyncBailHook<[string, string, any[]], true>;
        beforeRun: tapable.AsyncSeriesHook<[Compiler]>;
        run: tapable.AsyncSeriesHook<[Compiler]>;
        failed: tapable.SyncHook<[Error]>;
        watchRun: tapable.AsyncSeriesHook<[Compiler]>;
    };
    options: RspackOptionsNormalized;
    constructor(context: string, options: RspackOptionsNormalized);
    getInfrastructureLogger(name: string | Function): Logger;
    run(callback: any): void;
    build(cb: Callback<Error, binding.JsStatsCompilation>): void;
    rebuild(changedFiles: string[], cb: (error?: Error, stats?: binding.JsStatsCompilation) => void): void;
    watch(watchOptions?: Watch): Promise<Watching>;
    purgeInputFileSystem(): void;
    /**
     * @todo
     */
    close(callback: any): void;
    emitAssets(compilation: Compilation, callback: any): void;
}
export interface Watching {
    close(): Promise<void>;
}
export { Compiler };
//# sourceMappingURL=compiler.d.ts.map