"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _Compiler_instances, _Compiler__instance, _Compiler_instance_get, _Compiler_done, _Compiler_processAssets, _Compiler_compilation, _Compiler_newCompilation;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Compiler = void 0;
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
const util_1 = __importDefault(require("util"));
const tapable = __importStar(require("tapable"));
const tapable_1 = require("tapable");
const neo_async_1 = __importDefault(require("neo-async"));
const binding = __importStar(require("@rspack/binding"));
const Logger_1 = require("./logging/Logger");
const watch_1 = require("./config/watch");
const stats_1 = require("./stats");
const compilation_1 = require("./compilation");
const ResolverFactory_1 = __importDefault(require("./ResolverFactory"));
class EntryPlugin {
    apply() { }
}
class HotModuleReplacementPlugin {
    apply() { }
}
class Compiler {
    constructor(context, options) {
        _Compiler_instances.add(this);
        _Compiler__instance.set(this, void 0);
        this.options = options;
        // to workaround some plugin access webpack, we may change dev-server to avoid this hack in the future
        this.webpack = {
            EntryPlugin,
            HotModuleReplacementPlugin,
            get sources() {
                return require("webpack-sources");
            }
        };
        this.root = this;
        this.context = context;
        this.resolverFactory = new ResolverFactory_1.default();
        this.hooks = {
            initialize: new tapable_1.SyncHook([]),
            done: new tapable.AsyncSeriesHook(["stats"]),
            afterDone: new tapable.SyncHook(["stats"]),
            beforeRun: new tapable.AsyncSeriesHook(["compiler"]),
            run: new tapable.AsyncSeriesHook(["compiler"]),
            thisCompilation: new tapable.SyncHook([
                "compilation"
                // "params"
            ]),
            compilation: new tapable.SyncHook(["compilation"]),
            invalid: new tapable_1.SyncHook(["filename", "changeTime"]),
            compile: new tapable_1.SyncHook(["params"]),
            infrastructureLog: new tapable_1.SyncBailHook(["origin", "type", "args"]),
            failed: new tapable_1.SyncHook(["error"]),
            watchRun: new tapable.AsyncSeriesHook(["compiler"])
        };
    }
    getInfrastructureLogger(name) {
        if (!name) {
            throw new TypeError("Compiler.getInfrastructureLogger(name) called without a name");
        }
        return new Logger_1.Logger((type, args) => {
            if (typeof name === "function") {
                name = name();
                if (!name) {
                    throw new TypeError("Compiler.getInfrastructureLogger(name) called with a function not returning a name");
                }
            }
            else {
                if (this.hooks.infrastructureLog.call(name, type, args) === undefined) {
                    if (this.infrastructureLogger !== undefined) {
                        this.infrastructureLogger(name, type, args);
                    }
                }
            }
        }, childName => {
            if (typeof name === "function") {
                if (typeof childName === "function") {
                    return this.getInfrastructureLogger(_ => {
                        if (typeof name === "function") {
                            name = name();
                            if (!name) {
                                throw new TypeError("Compiler.getInfrastructureLogger(name) called with a function not returning a name");
                            }
                        }
                        if (typeof childName === "function") {
                            childName = childName();
                            if (!childName) {
                                throw new TypeError("Logger.getChildLogger(name) called with a function not returning a name");
                            }
                        }
                        return `${name}/${childName}`;
                    });
                }
                else {
                    return this.getInfrastructureLogger(() => {
                        if (typeof name === "function") {
                            name = name();
                            if (!name) {
                                throw new TypeError("Compiler.getInfrastructureLogger(name) called with a function not returning a name");
                            }
                        }
                        return `${name}/${childName}`;
                    });
                }
            }
            else {
                if (typeof childName === "function") {
                    return this.getInfrastructureLogger(() => {
                        if (typeof childName === "function") {
                            childName = childName();
                            if (!childName) {
                                throw new TypeError("Logger.getChildLogger(name) called with a function not returning a name");
                            }
                        }
                        return `${name}/${childName}`;
                    });
                }
                else {
                    return this.getInfrastructureLogger(`${name}/${childName}`);
                }
            }
        });
    }
    run(callback) {
        const doRun = () => {
            const finalCallback = (err, stats) => {
                if (err) {
                    this.hooks.failed.call(err);
                }
                if (callback) {
                    callback(err, stats);
                }
                this.hooks.afterDone.call(stats);
            };
            this.hooks.beforeRun.callAsync(this, err => {
                if (err) {
                    return finalCallback(err);
                }
                this.hooks.run.callAsync(this, err => {
                    if (err) {
                        return finalCallback(err);
                    }
                    this.build((err, rawStats) => {
                        if (err) {
                            return finalCallback(err);
                        }
                        const stats = new stats_1.Stats(rawStats, this.compilation);
                        this.hooks.done.callAsync(stats, err => {
                            if (err) {
                                return finalCallback(err);
                            }
                            else {
                                return finalCallback(null, stats);
                            }
                        });
                    });
                });
            });
        };
        doRun();
    }
    // Safety: This method is only valid to call if the previous build task is finished, or there will be data races.
    build(cb) {
        const build_cb = __classPrivateFieldGet(this, _Compiler_instances, "a", _Compiler_instance_get).unsafe_build.bind(__classPrivateFieldGet(this, _Compiler_instances, "a", _Compiler_instance_get));
        build_cb((err, stats) => {
            if (err) {
                cb(err);
            }
            else {
                cb(null, stats);
            }
        });
    }
    // Safety: This method is only valid to call if the previous rebuild task is finished, or there will be data races.
    rebuild(changedFiles, cb) {
        const rebuild_cb = __classPrivateFieldGet(this, _Compiler_instances, "a", _Compiler_instance_get).unsafe_rebuild.bind(__classPrivateFieldGet(this, _Compiler_instances, "a", _Compiler_instance_get));
        rebuild_cb(changedFiles, [], (err, stats) => {
            if (err) {
                cb(err);
            }
            else {
                this.hooks.done.callAsync(new stats_1.Stats(stats, this.compilation), err => {
                    if (err) {
                        throw err;
                    }
                });
                cb(null, stats);
            }
        });
    }
    async watch(watchOptions) {
        const options = (0, watch_1.resolveWatchOption)(watchOptions);
        let logger = this.getInfrastructureLogger("watch");
        const watcher = (await Promise.resolve().then(() => __importStar(require("chokidar")))).default.watch(this.options.context, {
            ignoreInitial: true,
            ...options
        });
        this.watcher = watcher;
        const begin = Date.now();
        let rawStats = await util_1.default.promisify(this.build.bind(this))();
        let stats = new stats_1.Stats(rawStats, this.compilation);
        await this.hooks.done.promise(stats);
        logger.log("build success, time cost", Date.now() - begin, "ms");
        let pendingChangedFilepaths = new Set();
        let isBuildFinished = true;
        // TODO: should use aggregated
        watcher.on("change", async (changedFilepath) => {
            // TODO: only build because we lack the snapshot info of file.
            // TODO: it means there a lot of things to do....
            // store the changed file path, it may or may not be consumed right now
            if (!isBuildFinished) {
                pendingChangedFilepaths.add(changedFilepath);
                console.log("hit change but rebuild is not finished, caching files: ", pendingChangedFilepaths);
                return;
            }
            const rebuildWithFilepaths = (changedFilepath) => {
                // Rebuild finished, we can start to rebuild again
                isBuildFinished = false;
                console.log("hit change and start to build:", changedFilepath);
                const begin = Date.now();
                this.rebuild(changedFilepath, (error, rawStats) => {
                    isBuildFinished = true;
                    const hasPending = Boolean(pendingChangedFilepaths.size);
                    // If we have any pending task left, we should rebuild again with the pending files
                    if (hasPending) {
                        const pending = [...pendingChangedFilepaths];
                        pendingChangedFilepaths.clear();
                        rebuildWithFilepaths(pending);
                    }
                    if (error) {
                        throw error;
                    }
                    console.log("rebuild success, time cost", Date.now() - begin, "ms");
                });
            };
            rebuildWithFilepaths([...pendingChangedFilepaths, changedFilepath]);
        });
        return {
            async close() {
                await watcher.close();
            }
        };
    }
    purgeInputFileSystem() {
        if (this.inputFileSystem && this.inputFileSystem.purge) {
            this.inputFileSystem.purge();
        }
    }
    /**
     * @todo
     */
    close(callback) {
        callback();
    }
    emitAssets(compilation, callback) {
        const outputPath = compilation.getPath(this.outputPath, {});
        fs_1.default.mkdirSync(outputPath, { recursive: true });
        const assets = compilation.getAssets();
        neo_async_1.default.forEachLimit(assets, 15, ({ name: file, source, info }, callback) => {
            let targetFile = file;
            const absPath = path_1.default.resolve(outputPath, targetFile);
            const getContent = () => {
                if (typeof source.buffer === "function") {
                    return source.buffer();
                }
                else {
                    const bufferOrString = source.source();
                    if (Buffer.isBuffer(bufferOrString)) {
                        return bufferOrString;
                    }
                    else {
                        return Buffer.from(bufferOrString, "utf-8");
                    }
                }
            };
            const doWrite = content => {
                this.outputFileSystem.writeFile(absPath, content, callback);
            };
            let content = getContent();
            doWrite(content);
        });
    }
}
exports.Compiler = Compiler;
_Compiler__instance = new WeakMap(), _Compiler_instances = new WeakSet(), _Compiler_instance_get = function _Compiler_instance_get() {
    const options = this.options;
    __classPrivateFieldSet(this, _Compiler__instance, __classPrivateFieldGet(this, _Compiler__instance, "f") ||
        new binding.Rspack(options, {
            done: __classPrivateFieldGet(this, _Compiler_instances, "m", _Compiler_done).bind(this),
            processAssets: __classPrivateFieldGet(this, _Compiler_instances, "m", _Compiler_processAssets).bind(this),
            // `Compilation` should be created with hook `thisCompilation`, and here is the reason:
            // We know that the hook `thisCompilation` will not be called from a child compiler(it doesn't matter whether the child compiler is created on the Rust or the Node side).
            // See webpack's API: https://webpack.js.org/api/compiler-hooks/#thiscompilation
            // So it is safe to create a new compilation here.
            thisCompilation: __classPrivateFieldGet(this, _Compiler_instances, "m", _Compiler_newCompilation).bind(this),
            // The hook `Compilation` should be called whenever it's a call from the child compiler or normal compiler and
            // still it does not matter where the child compiler is created(Rust or Node) as calling the hook `compilation` is a required task.
            // No matter how it will be implemented, it will be copied to the child compiler.
            compilation: __classPrivateFieldGet(this, _Compiler_instances, "m", _Compiler_compilation).bind(this)
        }), "f");
    return __classPrivateFieldGet(this, _Compiler__instance, "f");
}, _Compiler_done = function _Compiler_done(statsJson) { }, _Compiler_processAssets = async function _Compiler_processAssets() {
    await this.compilation.hooks.processAssets.promise(new Proxy({}, {
        get: (_, property) => {
            return this.compilation.__internal__getAssetSource(property);
        },
        has: (_, property) => {
            return this.compilation.__internal__hasAsset(property);
        },
        ownKeys: _ => {
            return this.compilation.__internal__getAssetFilenames();
        },
        getOwnPropertyDescriptor() {
            // To work with `Object.keys`, you should mark the property as enumerable.
            // See: https://262.ecma-international.org/7.0/#sec-enumerableownnames
            return {
                enumerable: true,
                configurable: true
            };
        }
    }));
}, _Compiler_compilation = function _Compiler_compilation(native) {
    // TODO: implement this based on the child compiler impl.
    this.hooks.compilation.call(this.compilation);
}, _Compiler_newCompilation = function _Compiler_newCompilation(native) {
    const compilation = new compilation_1.Compilation(this, native);
    this.compilation = compilation;
    this.hooks.thisCompilation.call(this.compilation);
};
//# sourceMappingURL=compiler.js.map