/// <reference types="node" />
/**
 * Filtering values.
 */
export declare type FilterTypes = FilterItemTypes[] | FilterItemTypes;
/**
 * Filtering value, regexp or function.
 */
export declare type FilterItemTypes = RegExp | string | ((value: string) => boolean);
export interface InfrastructureLogging {
    /**
     * Only appends lines to the output. Avoids updating existing output e. g. for status messages. This option is only used when no custom console is provided.
     */
    appendOnly?: boolean;
    /**
     * Enables/Disables colorful output. This option is only used when no custom console is provided.
     */
    colors?: boolean;
    /**
     * Custom console used for logging.
     */
    console?: Console;
    /**
     * Enable debug logging for specific loggers.
     */
    debug?: boolean | FilterTypes;
    /**
     * Log level.
     */
    level?: "none" | "error" | "warn" | "info" | "log" | "verbose";
    /**
     * Stream used for logging output. Defaults to process.stderr. This option is only used when no custom console is provided.
     */
    stream?: NodeJS.WritableStream;
}
//# sourceMappingURL=RspackOptions.d.ts.map