import type { RawBuiltins, RawHtmlPluginConfig, RawDecoratorOptions, Minification } from "@rspack/binding";
export declare type BuiltinsHtmlPluginConfig = Omit<RawHtmlPluginConfig, "meta"> & {
    meta?: Record<string, string | Record<string, string>>;
};
export declare type Builtins = Omit<RawBuiltins, "define" | "browserslist" | "html" | "decorator" | "minify"> & {
    define?: Record<string, string | undefined>;
    polyfillBuiltins?: boolean;
    html?: Array<BuiltinsHtmlPluginConfig>;
    decorator?: boolean | Partial<RawDecoratorOptions>;
    minify?: boolean | Partial<Minification>;
};
export declare type ResolvedBuiltins = Omit<RawBuiltins, "html"> & {
    polyfillBuiltins?: boolean;
    html?: Array<BuiltinsHtmlPluginConfig>;
};
export declare function resolveBuiltinsOptions(builtins: Builtins, { contextPath, isProduction }: {
    contextPath: string;
    isProduction: boolean;
}): ResolvedBuiltins;
export declare function resolveMinify(builtins: Builtins, isProduction: boolean): Minification;
//# sourceMappingURL=builtins.d.ts.map