"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveCacheOptions = void 0;
function resolveCacheOptions(cache) {
    const result = {
        type: "",
        maxGenerations: 0,
        maxAge: 0,
        profile: false,
        buildDependencies: [],
        cacheDirectory: "",
        cacheLocation: "",
        name: "",
        version: ""
    };
    if (cache === false) {
        return result;
    }
    if (cache === true) {
        return { ...result, type: "memory" };
    }
    if (cache.type === "memory") {
        cache.maxGenerations = isFinite(cache.maxGenerations)
            ? cache.maxGenerations
            : 0;
    }
    return {
        ...result,
        ...cache
    };
}
exports.resolveCacheOptions = resolveCacheOptions;
//# sourceMappingURL=cache.js.map