import type { Context, ResolvedContext } from "./context";
import type { Dev } from "./devServer";
import type { Entry, ResolvedEntry } from "./entry";
import type { External, ExternalType, ResolvedExternal, ResolvedExternalType } from "./external";
import type { Mode, ResolvedMode } from "./mode";
import type { Module, ResolvedModule, LoaderContext, Loader, SourceMap, GetCompiler } from "./module";
import type { PluginInstance } from "./plugin";
import type { ResolvedTarget, Target } from "./target";
import type { Output, ResolvedOutput } from "./output";
import type { Resolve, ResolvedResolve } from "./resolve";
import type { Builtins, ResolvedBuiltins } from "./builtins";
import type { Snapshot, ResolvedSnapshot } from "./snapshot";
import type { Cache, ResolvedCache } from "./cache";
import { Devtool, ResolvedDevtool } from "./devtool";
import { InfrastructureLogging } from "./RspackOptions";
import { ResolvedStatsOptions, StatsOptions } from "./stats";
import { Optimization, ResolvedOptimization } from "./optimization";
import { RawExperiments, RawNodeOption } from "@rspack/binding";
import { NodeOptions } from "./node";
export declare type Configuration = RspackOptions;
export interface RspackOptions {
    name?: string;
    entry?: Entry;
    context?: Context;
    plugins?: PluginInstance[];
    devServer?: Dev;
    module?: Module;
    target?: Target;
    mode?: Mode;
    externals?: External;
    externalsType?: ExternalType;
    output?: Output;
    builtins?: Builtins;
    resolve?: Resolve;
    devtool?: Devtool;
    infrastructureLogging?: InfrastructureLogging;
    stats?: StatsOptions;
    snapshot?: Snapshot;
    cache?: Cache;
    optimization?: Optimization;
    experiments?: RawExperiments;
    node?: NodeOptions;
}
export interface RspackOptionsNormalized {
    name?: string;
    entry: ResolvedEntry;
    context: ResolvedContext;
    plugins: PluginInstance[];
    devServer?: Dev;
    module: ResolvedModule;
    target: ResolvedTarget;
    mode: ResolvedMode;
    externals: ResolvedExternal;
    externalsType: ResolvedExternalType;
    output: ResolvedOutput;
    builtins: ResolvedBuiltins;
    resolve: ResolvedResolve;
    devtool: ResolvedDevtool;
    infrastructureLogging: InfrastructureLogging;
    stats: ResolvedStatsOptions;
    snapshot: ResolvedSnapshot;
    cache: ResolvedCache;
    optimization?: ResolvedOptimization;
    experiments: RawExperiments;
    node: RawNodeOption;
}
export declare function getNormalizedRspackOptions(config: RspackOptions, getCompiler: GetCompiler): RspackOptionsNormalized;
export type { PluginInstance as Plugin, LoaderContext, Loader, SourceMap };
export type { WebSocketServerOptions, Dev } from "./devServer";
export { resolveWatchOption } from "./watch";
export type { StatsOptions } from "./stats";
//# sourceMappingURL=index.d.ts.map