"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveWatchOption = exports.getNormalizedRspackOptions = void 0;
const entry_1 = require("./entry");
const devtool_1 = require("./devtool");
const target_1 = require("./target");
const output_1 = require("./output");
const module_1 = require("./module");
const builtins_1 = require("./builtins");
const resolve_1 = require("./resolve");
const snapshot_1 = require("./snapshot");
const cache_1 = require("./cache");
const stats_1 = require("./stats");
const optimization_1 = require("./optimization");
const experiments_1 = require("./experiments");
const node_1 = require("./node");
function getNormalizedRspackOptions(config, getCompiler) {
    var _a, _b, _c, _d, _e, _f, _g;
    const context = (_a = config.context) !== null && _a !== void 0 ? _a : process.cwd();
    const mode = (_b = config.mode) !== null && _b !== void 0 ? _b : "production";
    const entry = (0, entry_1.resolveEntryOptions)(config.entry, {
        context
    });
    const output = (0, output_1.resolveOutputOptions)(config.output);
    const target = (0, target_1.resolveTargetOptions)(config.target);
    const externals = (_c = config.externals) !== null && _c !== void 0 ? _c : {};
    const externalsType = (_d = config.externalsType) !== null && _d !== void 0 ? _d : "";
    const plugins = (_e = config.plugins) !== null && _e !== void 0 ? _e : [];
    const builtins = (0, builtins_1.resolveBuiltinsOptions)(config.builtins || {}, {
        contextPath: context,
        isProduction: mode === "production"
    });
    const resolve = (0, resolve_1.resolveResolveOptions)(config.resolve, { target });
    const devtool = (0, devtool_1.resolveDevtoolOptions)(config.devtool);
    const module = (0, module_1.resolveModuleOptions)(config.module, {
        devtool,
        context,
        target,
        getCompiler
    });
    const stats = (0, stats_1.resolveStatsOptions)(config.stats);
    const devServer = config.devServer;
    const snapshot = (0, snapshot_1.resolveSnapshotOptions)(config.snapshot);
    const cache = (0, cache_1.resolveCacheOptions)((_f = config.cache) !== null && _f !== void 0 ? _f : (mode === "production" ? false : true));
    const optimization = (0, optimization_1.resolveOptimizationOptions)((_g = config.optimization) !== null && _g !== void 0 ? _g : {}, mode);
    const experiments = (0, experiments_1.resolveExperiments)(config.experiments);
    const node = (0, node_1.resolveNode)(config.node);
    return {
        ...config,
        context,
        mode,
        devServer,
        entry,
        output,
        target,
        externals,
        externalsType,
        plugins,
        builtins,
        module,
        resolve,
        devtool,
        infrastructureLogging: cloneObject(config.infrastructureLogging),
        stats,
        snapshot,
        cache,
        optimization,
        experiments,
        node
    };
}
exports.getNormalizedRspackOptions = getNormalizedRspackOptions;
function cloneObject(value) {
    return { ...value };
}
var watch_1 = require("./watch");
Object.defineProperty(exports, "resolveWatchOption", { enumerable: true, get: function () { return watch_1.resolveWatchOption; } });
//# sourceMappingURL=index.js.map