"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveResolveOptions = void 0;
function resolveResolveOptions(resolve = {}, { target }) {
    var _a, _b, _c, _d, _e, _f, _g;
    const preferRelative = (_a = resolve.preferRelative) !== null && _a !== void 0 ? _a : false;
    const extensions = (_b = resolve.extensions) !== null && _b !== void 0 ? _b : [
        ".tsx",
        ".jsx",
        ".ts",
        ".js",
        ".json",
        ".d.ts"
    ];
    const defaultMainFields = ["module", "main"];
    if (target.includes("web")) {
        defaultMainFields.unshift("browser");
    }
    const mainFields = (_c = resolve.mainFields) !== null && _c !== void 0 ? _c : defaultMainFields;
    const mainFiles = (_d = resolve.mainFiles) !== null && _d !== void 0 ? _d : ["index"];
    const browserField = (_e = resolve.browserField) !== null && _e !== void 0 ? _e : true;
    const alias = (_f = resolve.alias) !== null && _f !== void 0 ? _f : {};
    const conditionNames = (_g = resolve.conditionNames) !== null && _g !== void 0 ? _g : ["module", "import"];
    const tsConfigPath = resolve.tsConfigPath;
    return {
        preferRelative,
        extensions,
        mainFiles,
        mainFields,
        browserField,
        conditionNames,
        alias,
        tsConfigPath
    };
}
exports.resolveResolveOptions = resolveResolveOptions;
//# sourceMappingURL=resolve.js.map