"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveSnapshotOptions = void 0;
function resolveSnapshotOptions(snapshot = {}) {
    const { resolveBuildDependencies, buildDependencies, resolve, module } = snapshot;
    const defaultSnapshotStrategy = {
        hash: false,
        timestamp: true
    };
    return {
        resolveBuildDependencies: {
            ...defaultSnapshotStrategy,
            ...resolveBuildDependencies
        },
        buildDependencies: { ...defaultSnapshotStrategy, ...buildDependencies },
        resolve: { ...defaultSnapshotStrategy, ...resolve },
        module: { ...defaultSnapshotStrategy, ...module }
    };
}
exports.resolveSnapshotOptions = resolveSnapshotOptions;
//# sourceMappingURL=snapshot.js.map