"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefaultTarget = exports.resolveTargetOptions = void 0;
const memoize_1 = require("../util/memoize");
function resolveTargetOptions(target = "web") {
    if (!target) {
        return [];
    }
    if (!Array.isArray(target)) {
        return [target];
    }
    return target;
}
exports.resolveTargetOptions = resolveTargetOptions;
const getBrowserslistTargetHandler = (0, memoize_1.memoize)(() => require("./browserslistTargetHandler"));
const getDefaultTarget = (context) => {
    const browsers = getBrowserslistTargetHandler().load(null, context);
    return resolveTargetOptions(browsers ? "browserslist" : "web");
};
exports.getDefaultTarget = getDefaultTarget;
//# sourceMappingURL=target.js.map