import * as binding from "@rspack/binding";
import { Compilation } from ".";
import { StatsOptions, StatsOptionsObj } from "./config/stats";
declare type StatsCompilationInner = Omit<binding.JsStatsCompilation, "entrypoints"> & {
    entrypoints: Record<string, binding.JsStatsEntrypoint>;
};
export declare type StatsCompilation = Partial<StatsCompilationInner> & {
    filteredModules?: number;
};
export declare class Stats {
    #private;
    compilation: Compilation;
    constructor(statsJson: binding.JsStatsCompilation, compilation: Compilation);
    get hash(): string;
    hasErrors(): boolean;
    hasWarnings(): boolean;
    toJson(opts?: StatsOptions, forToString?: boolean): StatsCompilation;
    toString(opts?: StatsOptions): string;
    static jsonToString(obj: any, useColors: boolean): string;
}
export declare const optionsOrFallback: (...args: any[]) => any;
export declare function normalizeStatsPreset(options?: StatsOptions): StatsOptionsObj;
export {};
//# sourceMappingURL=stats.d.ts.map