"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.memoize = void 0;
const memoize = (fn) => {
    let cache = false;
    let result = undefined;
    return () => {
        if (cache) {
            return result;
        }
        else {
            result = fn();
            cache = true;
            // Allow to clean up memory for fn
            // and all dependent resources
            fn = undefined;
            return result;
        }
    };
};
exports.memoize = memoize;
//# sourceMappingURL=memoize.js.map